#ifndef READWTB_DUMPWTB_H
#define READWTB_DUMPWTB_H

#include "welltype/wtruntime.h"

#define DWM__ALL        0xFFFFFFFFu
#define DWM_HEADER      0x00000001u
#define DWM_SECTIONS    0x00000002u
#define DWM_THREADS     0x00000004u
#define DWM_METADATA    0x00000008u
#define DWM_BOS         0x00000010u
#define DWM_CODE        0x00000020u
#define DWM_DATA        0x00000040u
#define DWM_DATABOSINTR 0x00000080u
#define DWM_ASSUMESTR   0x00000100u
#define DWM_SHOWDLABELS 0x00000200u
#define DWM_CODELABELS  0x00000400u
#define DWM_IMPORT      0x00000800u
#define DWM_EXPORT      0x00001000u
#define DWM_INTEGRITY   0x00002000u


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


/* Dump the WTB located in memory according the given mode. */
/* Returns 0 on success; non-zero otherwise. */
int dumpwtb(const void* data, wt_u32 size, wt_u32 mode);


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* READWTB_DUMPWTB_H */
