#include "config_private.h"
#include "types.h"
#include "wtruntime.h"

const char* wtrStrError(wt_error err)
{
	switch(err)
	{
	case WTE_OK:      return "Success";
	case WTE_BADARG:  return "Bad argument";
	case WTE_FAULT:   return "Bad address";
	case WTE_NOENT:   return "No such entity";
	case WTE_NOMEM:   return "Not enough memory";
	case WTE_NOFIT:   return "Data does not for in the given buffer";
	case WTE_DUPENT:  return "Entity duplication detected";
	case WTE_REFER:   return "Reference counter is non-zero";
	case WTE_BINERR:  return "General binary error";
	case WTE_BADVER:  return "Bad binary version or unsupported feature";
	case WTE_UNRES:   return "Unresolved external symbol";
	case WTE_AMBIG:   return "Ambiguous symbol";
	case WTE_BADEX:   return "Bad external";
	case WTE_URTEX:   return "Unhandled runtime exception";
	case WTE_INVOKE:  return "Failed to invoke main{} block or function";
	case WTE_INTEG:   return "Integrity check failed";
	case WTE_MEMSZ:   return "Specified memory is too small";
	case WTE_REFCTX:  return "Number of context references is non-zero";
	case WTE_BADCTX:  return "Context in bad state";
	case WTE_NOSTK:   return "Available stack is too small";
	case WTE_DESTRP:  return "Program destructor invoked";
	case WTE_UCLEAN:  return "Structure needs cleaning";
	case WTE_BADMAG:  return "Bad magic number";
	case WTE_ABIVER:  return "Binary ABI version out of supported range";
	case WTE_STKSZ:   return "Stack size is invalid";
	case WTE_VINVAL:  return "Invalid argument to VMMU";
	case WTE_VNSEGS:  return "Invalid number of VMMU segments";
	case WTE_VSEGSZ:  return "Bad VMMU segment size";
	case WTE_VINIT:   return "VMMU init failed";
	case WTE_BADHEAP: return "Bad heap configuration";
	case WTE_SYMNAME: return "Symbol name is too long";
	case WTE_HAINIT:  return "Hash algorithm init failed";
	case WTE_HADIGL:  return "Hash algorithm digest length out of range";
	case WTE_TYPEINF: return "Invalid type info in binary";
	case WTE_GIDFULL: return "GID-tree is full";
	case WTE_BADREL:  return "Invalid relocation type";
	case WTE_BADSYM:  return "Invalid symbol data in binary";
	case WTE_NREF:    return "Too many references";
	default:          return NULL;
	}
}
