#ifndef WTRUNTIME_GIDTREE_H
#define WTRUNTIME_GIDTREE_H

#include "config.h"
#include "wtruntime.h"
#include <stddef.h>

struct wtr_vm;
struct wtr_sym;

struct wtr_gidtree
{
	size_t levels; /* number of intermediate levels */
	void** root;
};

int wtr_gidtree_create(struct wtr_gidtree* const gidtree,
	struct wtr_vm* const vm);

void wtr_gidtree_release(struct wtr_gidtree* const gidtree,
	struct wtr_vm* const vm);

wt_error wtr_gidtree_add(struct wtr_gidtree* const gidtree,
	struct wtr_vm* const vm, wt_uint32_t* const out_gid,
	struct wtr_sym* const sym);

void wtr_gidtree_clear(struct wtr_gidtree* const gidtree, wt_globalid gid);

struct wtr_sym* wtr_gidtree_get(struct wtr_gidtree* const gidtree,
	wt_globalid gid);

/* returns zero on success; test() must return zero on success, and */
/* non-zero if test fails */
int wtr_gidtree_find(struct wtr_gidtree* const gidtree,
	wt_globalid* const out_gid, void* const ctx, int (*test)(void* const ctx,
	struct wtr_sym* const sym));

#endif /* WTRUNTIME_GIDTREE_H */
